'use strict';

exports.__esModule = true;

var _symbolObservable = require('symbol-observable');

var _symbolObservable2 = _interopRequireDefault(_symbolObservable);

var _changeEmitter = require('change-emitter');

var _setObservableConfig = require('./setObservableConfig');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createEventHandler = function createEventHandler() {
  var _fromESObservable;

  var emitter = (0, _changeEmitter.createChangeEmitter)();
  var stream = (0, _setObservableConfig.fromESObservable)((_fromESObservable = {
    subscribe: function subscribe(observer) {
      var unsubscribe = emitter.listen(function (value) {
        return observer.next(value);
      });
      return { unsubscribe: unsubscribe };
    }
  }, _fromESObservable[_symbolObservable2.default] = function () {
    return this;
  }, _fromESObservable));
  return {
    handler: emitter.emit,
    stream: stream
  };
};

exports.default = createEventHandler;