'use strict';

exports.__esModule = true;

var _symbolObservable = require('symbol-observable');

var _symbolObservable2 = _interopRequireDefault(_symbolObservable);

var _createEagerFactory = require('./createEagerFactory');

var _createEagerFactory2 = _interopRequireDefault(_createEagerFactory);

var _createHelper = require('./createHelper');

var _createHelper2 = _interopRequireDefault(_createHelper);

var _componentFromStream = require('./componentFromStream');

var _componentFromStream2 = _interopRequireDefault(_componentFromStream);

var _setObservableConfig = require('./setObservableConfig');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapPropsStream = function mapPropsStream(transform) {
  return function (BaseComponent) {
    var factory = (0, _createEagerFactory2.default)(BaseComponent);
    return (0, _componentFromStream2.default)(function (ownerProps$) {
      var _ref;

      return _ref = {
        subscribe: function subscribe(observer) {
          var subscription = (0, _setObservableConfig.toESObservable)(transform(ownerProps$)).subscribe({
            next: function next(childProps) {
              return observer.next(factory(childProps));
            }
          });
          return {
            unsubscribe: function unsubscribe() {
              return subscription.unsubscribe();
            }
          };
        }
      }, _ref[_symbolObservable2.default] = function () {
        return this;
      }, _ref;
    });
  };
};

exports.default = (0, _createHelper2.default)(mapPropsStream, 'mapPropsStream');